/*
_____       _    _    Corso   Italia,  178
(_|__   .  (_   |_|_  56125           Pisa
(_|_) |)|(()_)()| |   tel.  +39  050 46380
  |   |               picosoft@picosoft.it

 Copyright (C) Picosoft s.r.l. 1995-2002

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/
package IT.picosoft.jdbc;
import java.sql.*;
public class OdbcConnection {
   private int hDbc = 0;
   private PicoDbApi odbcApi;
   public OdbcConnection (PicoDbApi api, String connStr, String user, String passwd)
      throws SQLException {
      odbcApi = api;
      hDbc = odbcApi.SQLConnect (connStr, user, passwd);
   }
   public synchronized int getHDBC() {return hDbc;}
   public synchronized boolean isClosed() {return hDbc == 0;}
   public synchronized void close () throws SQLException {
      if (hDbc != 0) {
         odbcApi.SQLDisconnect(this);
         odbcApi.SQLFreeConnect(this);
         hDbc = 0;
      }
   }
   public void finalize() {
      try {close();}
      catch (SQLException e) {}
   }
   public synchronized String toString() {return super.toString() + ", hDbc=" + hDbc;}
}
